// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from camera_aravis2_msgs:srv/CalculateWhiteBalance.idl
// generated code does not contain a copyright notice

#ifndef CAMERA_ARAVIS2_MSGS__SRV__DETAIL__CALCULATE_WHITE_BALANCE__STRUCT_HPP_
#define CAMERA_ARAVIS2_MSGS__SRV__DETAIL__CALCULATE_WHITE_BALANCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Request __attribute__((deprecated))
#else
# define DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Request __declspec(deprecated)
#endif

namespace camera_aravis2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CalculateWhiteBalance_Request_
{
  using Type = CalculateWhiteBalance_Request_<ContainerAllocator>;

  explicit CalculateWhiteBalance_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit CalculateWhiteBalance_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Request
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Request
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CalculateWhiteBalance_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const CalculateWhiteBalance_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CalculateWhiteBalance_Request_

// alias to use template instance with default allocator
using CalculateWhiteBalance_Request =
  camera_aravis2_msgs::srv::CalculateWhiteBalance_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace camera_aravis2_msgs


// Include directives for member types
// Member 'balance_ratios'
#include "diagnostic_msgs/msg/detail/key_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Response __attribute__((deprecated))
#else
# define DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Response __declspec(deprecated)
#endif

namespace camera_aravis2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CalculateWhiteBalance_Response_
{
  using Type = CalculateWhiteBalance_Response_<ContainerAllocator>;

  explicit CalculateWhiteBalance_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_successful = false;
    }
  }

  explicit CalculateWhiteBalance_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_successful = false;
    }
  }

  // field types and members
  using _is_successful_type =
    bool;
  _is_successful_type is_successful;
  using _balance_ratios_type =
    std::vector<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>>>;
  _balance_ratios_type balance_ratios;

  // setters for named parameter idiom
  Type & set__is_successful(
    const bool & _arg)
  {
    this->is_successful = _arg;
    return *this;
  }
  Type & set__balance_ratios(
    const std::vector<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<diagnostic_msgs::msg::KeyValue_<ContainerAllocator>>> & _arg)
  {
    this->balance_ratios = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Response
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__camera_aravis2_msgs__srv__CalculateWhiteBalance_Response
    std::shared_ptr<camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CalculateWhiteBalance_Response_ & other) const
  {
    if (this->is_successful != other.is_successful) {
      return false;
    }
    if (this->balance_ratios != other.balance_ratios) {
      return false;
    }
    return true;
  }
  bool operator!=(const CalculateWhiteBalance_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CalculateWhiteBalance_Response_

// alias to use template instance with default allocator
using CalculateWhiteBalance_Response =
  camera_aravis2_msgs::srv::CalculateWhiteBalance_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace camera_aravis2_msgs

namespace camera_aravis2_msgs
{

namespace srv
{

struct CalculateWhiteBalance
{
  using Request = camera_aravis2_msgs::srv::CalculateWhiteBalance_Request;
  using Response = camera_aravis2_msgs::srv::CalculateWhiteBalance_Response;
};

}  // namespace srv

}  // namespace camera_aravis2_msgs

#endif  // CAMERA_ARAVIS2_MSGS__SRV__DETAIL__CALCULATE_WHITE_BALANCE__STRUCT_HPP_
